void getrho(long long rho[AMAX_ARRAY][EMAX_ARRAY][JMAX_ARRAY],int iemax,levelinfoclass *levelinfo,int jjmax[AMAX_ARRAY][EMAX_ARRAY]){
  int ilevel,n,j,jj,ij,jmin,jmax,a,ie,je,aa,sign,nmax,biggestj,oddeven,iemin;
  int jemin;
  double realjj,realij,m,m_min,m_max;

  for(a=0;a<=levelinfo->amax;a++){
    for(ie=0;ie<=iemax;ie++){
      for(j=0;j<JMAX_ARRAY;j++){
	rho[a][ie][j]=0;
      }
      jjmax[a][ie]=0;
    }
  }
  biggestj=0;

  rho[0][0][0]=1;

  for(a=1;a<=levelinfo->amax;a++){
    iemin=levelinfo->ie0[a];
    for(ie=iemin;ie<=iemax;ie++){
      sign=-1;
      for(n=1;n<=a;n++){
	sign=-sign;
	oddeven=(int)pow(-1,a-n);

	ilevel=0;
	//while(ilevel<levelinfo->nlevels&&je>=levelinfo->ie0[a-n]){
	for(ilevel=0;ilevel<levelinfo->nlevels;ilevel++){
	  je=ie-n*levelinfo->ienergy[ilevel];
	  jemin=levelinfo->ie0[a-n];
	  if(je>=jemin){
	    
	    for(jj=0;jj<=jjmax[a-n][je];jj++){
	      
	      if(oddeven==1){
		realjj=jj;
	      }
	      else{
		realjj=jj+0.5;
	      }
	      m_max=levelinfo->jcode[ilevel]+0.5;
	      m_min=-m_max;
	      
	      for(m=m_min;m<=m_max+0.00001;m=m+1.0){
		
		//		cout << form("Here inside, m=%g\n",m);
		realij=realjj+n*m;
		if(realij>-0.001){
		  ij=int(floor(realij+0.0001));
		  if(ij>jjmax[a][ie]) {
		    jjmax[a][ie]=ij;
		    if(ij>biggestj) biggestj=ij;
		    if(jjmax[a][ie]>=JMAX_ARRAY){
		      cout << "a. INCREASE JMAX_ARAY\n";
		      exit(1);
		    }
		  }
		  rho[a][ie][ij]=rho[a][ie][ij]
		    +sign*rho[a-n][je][jj]*levelinfo->antistate[ilevel];
		}
		realij=-realjj+n*m-1;
		if(realij>-0.001){
		  ij=int(floor(realij+0.0001));
		  if(ij>jjmax[a][ie]) {
		    jjmax[a][ie]=ij;
		    if(ij>biggestj) biggestj=ij;
		    if(jjmax[a][ie]>=JMAX_ARRAY){
		      cout << "b. INCREASE JMAX_ARRAY\n";
		      exit(1);
		    }
		  }
		  rho[a][ie][ij]=rho[a][ie][ij]
		    -sign*rho[a-n][je][jj]*levelinfo->antistate[ilevel];

		}
	      }
	    }
	  }
	}
      }
      for(ij=0;ij<JMAX_ARRAY;ij++){
	if(fabs(fmod((double)rho[a][ie][ij],(double)a))>0.0001){
	  cout << form("non-integer counting, fmod=%g\n",
		       fmod((double)rho[a][ie][ij],(double)a) );
	  cout << form ("a=%d ie=%d j=%d, rho=%d\n",a,ie,j,rho[a]);
	  //exit(1);
	}
	  rho[a][ie][ij]=rho[a][ie][ij]/a;
	  if(rho[a][ie][ij]<-10000000){
	    cout << form("possible overflow, a=%d, ie=%d ij=%d \n",a,ie,ij);
	    exit(1);
	  }
	  }
      }
    cout << "finished for a="<<a<<endl;
  }

}

void shell_sort(int n, double *a, int *b){
  long i,j,inc;
  double va;
  int vb;
  inc=1;
  do {
    inc *=3;
    inc++;
  } while (inc <= n);
  do {
    inc /= 3;
    for (i=inc+1;i<=n;i++) {
      va=a[i];
      vb=b[i];
      j=i;
      while (a[j-inc]>va) {
	a[j]=a[j-inc];
	b[j]=b[j-inc];
	j-=inc;
	if(j<=inc) break;
      }
      a[j]=va;
      b[j]=vb;
    }
  } while (inc>1);
}

void levelsetter(char *filename,int iemax,double ef,int upordown,levelinfoclass *levelinfo){
  int nlevels,ilevel,ii,j,twojplus1,magic,i,amax;
  int jcodetemp[NLEVELS_ARRAY],iorder[NLEVELS_ARRAY],antistate[NLEVELS_ARRAY];
  double energytemp[NLEVELS_ARRAY],energy;
  int leveldens[1000];
  ifstream hflevels_file;
  ofstream rho_file;
  char cdummy[100];

  levelinfo->antistatecheck=1;
  nlevels=0;
  hflevels_file.open(filename);
  //  hflevels_file.getline(cdummy,100);
  ilevel=0;
  for(i=0;i<EMAX_ARRAY;i++) leveldens[i]=0;
  while(hflevels_file >> ii >> j >> energy >> magic){
    hflevels_file.getline(cdummy,100);
    if(upordown==1){
      if(energy>ef){
	ilevel=ilevel+1;
	jcodetemp[ilevel]=j;
	iorder[ilevel]=ilevel;
	energytemp[ilevel]=energy-ef;
	nlevels=nlevels+1;
	antistate[ilevel]=1;
	if(ii<0){
	  antistate[ilevel]=-1;
	  levelinfo->antistatecheck=-1;
	}
      }
    }
    else{
      cout << form("doing holes, energy=%g  ef=%g\n",energy,ef);
      if(energy<ef){
	ilevel=ilevel+1;
	jcodetemp[ilevel]=j;
	iorder[ilevel]=ilevel;
	energytemp[ilevel]=ef-energy;
	nlevels=nlevels+1;
	antistate[ilevel]=1;
	if(ii<0){
	  antistate[ilevel]=-1;
	  levelinfo->antistatecheck=-1;
	}
	cout << form("doing holes, nlevels=%d\n",nlevels);
      }
    }
  }

  hflevels_file.close();

  shell_sort(nlevels,energytemp,iorder);
  for(ilevel=0;ilevel<nlevels;ilevel++){
    levelinfo->ienergy[ilevel]=int(floor((energytemp[ilevel+1])/ESCALE));
    levelinfo->jcode[ilevel]=jcodetemp[iorder[ilevel+1]];
    levelinfo->antistate[ilevel]=antistate[iorder[ilevel+1]];
    if(upordown==1) cout << "PARTICLE: ";
    if(upordown==-1) cout << "HOLE: ";
    cout << form("ilevel=%d ie=%d j=%d antistate=%d\n",
		 ilevel,levelinfo->ienergy[ilevel],levelinfo->jcode[ilevel],levelinfo->antistate[ilevel]);
  }

  amax=0;
  levelinfo->ie0[0]=0;
  iemax=EMAX_ARRAY-1;

  for(ilevel=0;ilevel<nlevels;ilevel++){
    twojplus1=2*(1+levelinfo->jcode[ilevel]);
    leveldens[levelinfo->ienergy[ilevel]]=leveldens[levelinfo->ienergy[ilevel]]+twojplus1*levelinfo->antistate[ilevel];
    if(levelinfo->antistate>0){
      for(i=0;i<twojplus1;i++){
	if(levelinfo->ie0[amax]+levelinfo->ienergy[ilevel]<=iemax){
	  amax=amax+1;
	  levelinfo->ie0[amax]=levelinfo->ie0[amax-1]+levelinfo->ienergy[ilevel];
	  cout << form("a=%d, ie0=%d state/antistate=%d\n",amax,levelinfo->ie0[amax],levelinfo->antistate[ilevel]);
	  if(levelinfo->ie0[amax]>=EMAX_ARRAY) levelinfo->ie0[amax]=EMAX_ARRAY;
	}
      }
    }
  }
  if(amax>=AMAX_ARRAY){
    cout << "amax set to AMAX_ARRAY\n";
    amax=AMAX_ARRAY;
  }
  levelinfo->amax=amax;
  levelinfo->nlevels=nlevels;


  if(upordown==1){
    rho_file.open("oneparticle_rho.dat");
    for(i=0;i<EMAX_ARRAY;i++){
      rho_file << leveldens[i]<<endl;
    }
    rho_file.close();
  }
}
