#include <stream.h>
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#define pi 3.14159265358979323844

const int NEMAX=200;
const int NJMAX=28;
const double DELE=5.0;
const double estarstep=0.25;

void main(){
  long long pcount[NEMAX+1][NJMAX]={0};
  long long ncount[NEMAX+1][NJMAX]={0};
  long long delcount,netcount[2*NEMAX+1]={0};
  long long count[NEMAX+1][2*NJMAX+1]={0};
  ifstream nfile,pfile;
  ofstream results_file;
  char pfilename[80],nfilename[80];
  char dummy[80];
  int j,jp,jn,jmin,jmax,n,np,nstates,iep,ien,ie,ie0,iemax;
  int iepmin[NJMAX]={0},iepmax[NJMAX];
  int ienmin[NJMAX]={0},ienmax[NJMAX];
  int binsize;
  double estar;
  for(jp=0;jp<=NJMAX;jp++){
    strcpy(pfilename,form("presults/rho_j%03d.dat",jp));
    pfile.open(pfilename);
    pfile.getline(dummy,80);
    while(pfile){
      pfile >> iep >> estar >> np >> nstates;
      iep=int(floor(estar/estarstep));
      if(iep <=NEMAX && np >0){
	pcount[iep][jp]=pcount[iep][jp]+np;
	pfile.getline(dummy,80);
	if(np!=0&&iepmin[jp]!=0) iepmin[jp]=iep;
	if(np!=0) iepmax[jp]=iep;
      }
    }
    pfile.close();
  }
  for(jn=0;jn<=NJMAX;jn++){
    strcpy(nfilename,form("nresults/rho_j%03d.dat",jn));
    nfile.open(nfilename);
    nfile.getline(dummy,80);
    while(nfile){
      nfile >> ien >> estar >> np >> nstates;
      ien=int(floor(estar/estarstep));
      if(ien <=NEMAX && np >0){
	ncount[ien][jn]=ncount[ien][jn]+np;
	nfile.getline(dummy,80);
	if(np!=0&&ienmin[jn]!=0) ienmin[jn]=ien;
	if(np!=0) ienmax[jn]=ien;
      }
    }
    nfile.close();
  }


  iemax=int(floor(NEMAX*estarstep/DELE));
  for(jp=0;jp<NJMAX;jp++){
    for(jn=0;jn<NJMAX;jn++){
      jmin=jp-jn;
      if(jmin<0) jmin=-jmin;
      for(j=jmin;j<=(jp+jn);j++){
	if(j<2*NJMAX){
	  for(iep=iepmin[jp];iep<=iepmax[jp];iep++){
	    for(ien=ienmin[jn];ien<=ienmax[jn];ien++){
	      ie=(int)floor((iep+ien)*estarstep/DELE);
	      if(ie<=iemax){
		delcount=pcount[iep][jp]*ncount[ien][jn];
		count[ie][j]=count[ie][j]+delcount;
		netcount[iep+ien]=netcount[iep+ien]
		  +(2*j+1)*delcount;
	      }
	    }
	  }
	}
      }
      //cout << form("finished convolution for jp=%d jn=%d\n",jp,jn);
    }
  }


  results_file.open("binbyj.dat");
  for(j=0;j<2*NJMAX;j++){
    results_file << setw(10) << j;
    for(ie=0;ie<iemax;ie++){
      results_file << setw(12) << double(count[ie][j]);
    }
    results_file << endl;
  }
  results_file.close();

  binsize=8;
  results_file.open("pnrho.dat");
  for(ie0=0;ie0<=NEMAX-binsize;ie0=ie0+binsize){
    estar=estarstep*(ie0+binsize/2);
    delcount=0;
    for(ie=ie0;ie<ie0+binsize;ie++){
      delcount=delcount+netcount[ie];
    }
    results_file << setw(12) << estar << "   " << setw(11) << double(delcount)/(binsize*estarstep) <<endl;

  }
  results_file.close();

}
